/*
 * Copyright (C) 2014 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#pragma version(1)
#pragma rs java_package_name(android.renderscript.cts)

// Don't edit this file!  It is auto-generated by frameworks/rs/api/gen_runtime.

rs_allocation gAllocInStop;
rs_allocation gAllocInAmount;

float __attribute__((kernel)) testMixFloatFloatFloatFloat(float inStart, unsigned int x) {
    float inStop = rsGetElementAt_float(gAllocInStop, x);
    float inAmount = rsGetElementAt_float(gAllocInAmount, x);
    return mix(inStart, inStop, inAmount);
}

float2 __attribute__((kernel)) testMixFloat2Float2Float2Float2(float2 inStart, unsigned int x) {
    float2 inStop = rsGetElementAt_float2(gAllocInStop, x);
    float2 inAmount = rsGetElementAt_float2(gAllocInAmount, x);
    return mix(inStart, inStop, inAmount);
}

float3 __attribute__((kernel)) testMixFloat3Float3Float3Float3(float3 inStart, unsigned int x) {
    float3 inStop = rsGetElementAt_float3(gAllocInStop, x);
    float3 inAmount = rsGetElementAt_float3(gAllocInAmount, x);
    return mix(inStart, inStop, inAmount);
}

float4 __attribute__((kernel)) testMixFloat4Float4Float4Float4(float4 inStart, unsigned int x) {
    float4 inStop = rsGetElementAt_float4(gAllocInStop, x);
    float4 inAmount = rsGetElementAt_float4(gAllocInAmount, x);
    return mix(inStart, inStop, inAmount);
}

float2 __attribute__((kernel)) testMixFloat2Float2FloatFloat2(float2 inStart, unsigned int x) {
    float2 inStop = rsGetElementAt_float2(gAllocInStop, x);
    float inAmount = rsGetElementAt_float(gAllocInAmount, x);
    return mix(inStart, inStop, inAmount);
}

float3 __attribute__((kernel)) testMixFloat3Float3FloatFloat3(float3 inStart, unsigned int x) {
    float3 inStop = rsGetElementAt_float3(gAllocInStop, x);
    float inAmount = rsGetElementAt_float(gAllocInAmount, x);
    return mix(inStart, inStop, inAmount);
}

float4 __attribute__((kernel)) testMixFloat4Float4FloatFloat4(float4 inStart, unsigned int x) {
    float4 inStop = rsGetElementAt_float4(gAllocInStop, x);
    float inAmount = rsGetElementAt_float(gAllocInAmount, x);
    return mix(inStart, inStop, inAmount);
}
