/*
 * Copyright (C) 2014 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package android.uirendering.cts.testinfrastructure;

import android.graphics.Canvas;

/**
 * A class that the tester will implement and create a set of drawing calls the tests would use
 */
public abstract class CanvasClient {
    private String mDebugString;

    public abstract void draw(Canvas canvas, int width, int height);

    public String getDebugString() {
        return mDebugString;
    }

    public void setDebugString(String debugString) {
        mDebugString = debugString;
    }
}
